/**
 * @file MML_Parser.cpp
 * @author Shinichiro Nakamura
 * @copyright
 * ===============================================================
 * A tiny MML parser (Version 0.4.0)
 * ===============================================================
 * Copyright (c) 2014-2015 Shinichiro Nakamura
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

#include "MML_Parser.h"

#ifdef __cplusplus
extern "C" {
#endif

    static void local_mml_callback(MML_INFO *p, void *extobj)
    {
        MML_Listener *l = (MML_Listener *)extobj;
        l->info(p);
    }

#ifdef __cplusplus
}
#endif

MML_Parser::MML_Parser(MML_Listener *listener, int octave, int length, int bticks) : octave(octave), length(length), bticks(bticks)
{
    mml_init(&mml, local_mml_callback, (void *)listener);
}

MML_Parser::~MML_Parser()
{
}

MML_RESULT MML_Parser::setup(char *text)
{
    MML_OPTION opt;
    MML_OPTION_INITIALIZER(&opt, octave, length, bticks);
    return mml_setup(&mml, &opt, text);
}

MML_RESULT MML_Parser::fetch()
{
    return mml_fetch(&mml);
}

